"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const IconButton_1 = tslib_1.__importDefault(require("@material-ui/core/IconButton"));
const react_1 = tslib_1.__importDefault(require("react"));
const uniforms_1 = require("uniforms");
function ListDel(_a) {
    var { disabled, icon = '-', name, readOnly } = _a, props = tslib_1.__rest(_a, ["disabled", "icon", "name", "readOnly"]);
    const nameParts = uniforms_1.joinName(null, name);
    const nameIndex = +nameParts[nameParts.length - 1];
    const parentName = uniforms_1.joinName(nameParts.slice(0, -1));
    const parent = uniforms_1.useField(parentName, {}, { absoluteName: true })[0];
    const limitNotReached = !disabled && !(parent.minCount >= parent.value.length);
    return (react_1.default.createElement(IconButton_1.default, Object.assign({}, uniforms_1.filterDOMProps(props), { disabled: !limitNotReached, onClick: () => {
            if (!readOnly) {
                const value = parent.value.slice();
                value.splice(nameIndex, 1);
                parent.onChange(value);
            }
        } }), icon));
}
exports.default = uniforms_1.connectField(ListDel, {
    initialValue: false,
    kind: 'leaf',
});
