import { CheckboxProps } from '@material-ui/core/Checkbox';
import { SelectProps as MaterialSelectProps } from '@material-ui/core/Select';
import { SwitchProps } from '@material-ui/core/Switch';
import { TextFieldProps } from '@material-ui/core/TextField';
import { Ref } from 'react';
import { FieldProps, Override } from 'uniforms';
declare type SelectFieldCommonProps = {
    allowedValues?: string[];
    appearance?: 'checkbox' | 'switch';
    disableItem?: (value: string) => boolean;
    inputRef?: Ref<HTMLButtonElement>;
    required?: boolean;
    transform?: (value: string) => string;
    variant?: 'standard' | 'outlined' | 'filled';
};
declare type CheckboxesProps = FieldProps<string | string[], CheckboxProps | SwitchProps, SelectFieldCommonProps & {
    checkboxes: true;
    legend?: string;
}>;
declare type SelectProps = FieldProps<string | string[], Override<MaterialSelectProps & TextFieldProps, {
    margin?: 'normal' | 'dense' | 'none';
}>, SelectFieldCommonProps & {
    checkboxes?: false;
    labelProps?: object;
    native?: boolean;
    textFieldProps?: Omit<TextFieldProps, 'value'>;
}>;
export declare type SelectFieldProps = CheckboxesProps | SelectProps;
declare const _default: import("uniforms").ConnectedField<SelectFieldProps, string | string[] | undefined>;
export default _default;
